package encounter_document

import (
	"net/http"

	d "github.com/karincake/dodol"
	rw "github.com/karincake/risoles"
	sf "github.com/karincake/semprit"

	e "simrs-vx/internal/domain/main-entities/encounter-document"
	u "simrs-vx/internal/use-case/main-use-case/encounter-document"
)

type myBase struct{}

var O myBase

func (obj myBase) Create(w http.ResponseWriter, r *http.Request) {
	dto := e.CreateDto{}
	if res := rw.ValidateStructByIOR(w, r.Body, &dto); !res {
		return
	}
	res, err := u.Create(dto)
	rw.DataResponse(w, res, err)
}

func (obj myBase) GetList(w http.ResponseWriter, r *http.Request) {
	dto := e.ReadListDto{}
	sf.UrlQueryParam(&dto, *r.URL)

	if dto.Encounter_Id == nil {
		rw.DataResponse(w, nil, d.FieldError{
			Code:    "data-validation-fail",
			Message: "filter encounter-id required",
		})
		return
	}
	res, err := u.ReadList(dto)
	rw.DataResponse(w, res, err)
}

func (obj myBase) GetDetail(w http.ResponseWriter, r *http.Request) {
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}
	dto := e.ReadDetailDto{}

	sf.UrlQueryParam(&dto, *r.URL)
	dto.Id = uint16(id)
	res, err := u.ReadDetail(dto)
	rw.DataResponse(w, res, err)
}

func (obj myBase) Update(w http.ResponseWriter, r *http.Request) {
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}

	dto := e.UpdateDto{}
	if res := rw.ValidateStructByIOR(w, r.Body, &dto); !res {
		return
	}
	dto.Id = uint16(id)
	res, err := u.Update(dto)
	rw.DataResponse(w, res, err)
}

func (obj myBase) Delete(w http.ResponseWriter, r *http.Request) {
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}

	dto := e.DeleteDto{}
	dto.Id = uint16(id)
	res, err := u.Delete(dto)
	rw.DataResponse(w, res, err)
}
